/*
 * LinRemote : a program to emulate Mindstorms Remote under linux
 * Copyright (C) 2003  nanobapt
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 */
 
/* 
 * GTK mode function
 */
 
#include <gtk/gtk.h>
#include <stdio.h>
#include <unistd.h>
#include "IO.h"
#include "rcx_com.h"

int fd;

 
static void releas( GtkWidget *widget, gpointer   data )
{
	command(data, GTK_MODE, fd);
}

static void callback( GtkWidget *widget, gpointer   data )
{
	/*
	 * Callback function
	 * 	Just send the correct message to RCX
	 */
	
	command(data, GTK_MODE, fd);
}


void cWin(int tty) 
{
	/*
	 * Here is program the window 
	 */
	
	//some declaration
	
    GtkWidget *window;
    GtkWidget *button;
    GtkWidget *table;
    GtkWidget *table2;
    GtkWidget *label;
 
	// First create window
	
	fd=tty;
    
    window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
    gtk_window_set_title (GTK_WINDOW (window), "Linux MindRemote"); //window title
    gtk_window_set_default_size(GTK_WINDOW(window), 150, 10); // size of window
    g_signal_connect (G_OBJECT (window), "delete_event", G_CALLBACK(gtk_main_quit), NULL); // if want to quit ...
    gtk_container_set_border_width (GTK_CONTAINER (window), 5); // a little border
    
    // Create a big table with all component
    
    table2 = gtk_table_new (10, 1, TRUE);
    gtk_container_add (GTK_CONTAINER (window), table2);
    
    label=gtk_label_new("Message"); // message label
	gtk_table_attach_defaults(GTK_TABLE(table2), label, 0, 1, 0, 1); //put it in table
	gtk_widget_show(label); //display it

	/*
	 * Create the 1st row bouton (message)
	 */
	
    table = gtk_table_new (1, 3, TRUE);
    gtk_table_attach_defaults(GTK_TABLE(table2), table, 0, 1, 1, 2);

    button = gtk_button_new_with_label ("1");
    g_signal_connect (G_OBJECT (button), "clicked", G_CALLBACK (callback), (gpointer) MESSAGE_1);
    gtk_table_attach_defaults (GTK_TABLE (table), button, 0, 1, 0, 1);
	gtk_widget_show (button); // montrer le bouton
	
	button = gtk_button_new_with_label ("2");
    g_signal_connect (G_OBJECT (button), "clicked", G_CALLBACK (callback), (gpointer) MESSAGE_2);
    gtk_table_attach_defaults (GTK_TABLE (table), button, 1, 2, 0, 1);
	gtk_widget_show (button); // montrer le bouton
	
	button = gtk_button_new_with_label ("3");
    g_signal_connect (G_OBJECT (button), "clicked", G_CALLBACK (callback), (gpointer) MESSAGE_3);
    gtk_table_attach_defaults (GTK_TABLE (table), button, 2, 3, 0, 1);
	gtk_widget_show (button); // montrer le bouton
	
	gtk_table_set_col_spacings(GTK_TABLE(table), 5); //espacement entre les cases
	
    gtk_widget_show (table);
    
    //show 1st row
    
    /*
     * Motors buttons
     */
    
    table = gtk_table_new (1, 3, TRUE);
    gtk_table_attach_defaults(GTK_TABLE(table2), table, 0, 1, 3, 4);
    
    label=gtk_label_new("A");
	gtk_table_attach_defaults(GTK_TABLE(table), label, 0, 1, 0, 1);
	gtk_widget_show(label);
	
	label=gtk_label_new("B");
	gtk_table_attach_defaults(GTK_TABLE(table), label, 1, 2, 0, 1);
	gtk_widget_show(label);
	
	label=gtk_label_new("C");
	gtk_table_attach_defaults(GTK_TABLE(table), label, 2, 3, 0, 1);
	gtk_widget_show(label);
	
	gtk_widget_show (table);
	
	table = gtk_table_new (1, 3, TRUE);
    gtk_table_attach_defaults(GTK_TABLE(table2), table, 0, 1, 4, 5);
	
	button = gtk_button_new_with_label ("/\\");
    g_signal_connect (G_OBJECT (button), "pressed", G_CALLBACK (callback), (gpointer) FWD_A);
    g_signal_connect (G_OBJECT (button), "released", G_CALLBACK (releas), (gpointer) STOP_A);
    gtk_table_attach_defaults (GTK_TABLE (table), button, 0, 1, 0, 1);
	gtk_widget_show (button); 
	
	button = gtk_button_new_with_label ("/\\");
    g_signal_connect (G_OBJECT (button), "pressed", G_CALLBACK (callback), (gpointer) FWD_B);
    g_signal_connect (G_OBJECT (button), "released", G_CALLBACK (releas), (gpointer) STOP_B);
    gtk_table_attach_defaults (GTK_TABLE (table), button, 1, 2, 0, 1);
	gtk_widget_show (button); 
	
	button = gtk_button_new_with_label ("/\\");
    g_signal_connect (G_OBJECT (button), "pressed", G_CALLBACK (callback), (gpointer) FWD_C);
    g_signal_connect (G_OBJECT (button), "released", G_CALLBACK (releas), (gpointer) STOP_C);
    gtk_table_attach_defaults (GTK_TABLE (table), button, 2, 3, 0, 1);
	gtk_widget_show (button); 
	
	gtk_table_set_col_spacings(GTK_TABLE(table), 5);
	
	// reverse bouton
	
	gtk_widget_show(table);
	
	table = gtk_table_new (1, 3, TRUE);
    gtk_table_attach_defaults(GTK_TABLE(table2), table, 0, 1, 5, 6);
	
	button = gtk_button_new_with_label ("\\/");
    g_signal_connect (G_OBJECT (button), "pressed", G_CALLBACK (callback), (gpointer) REV_A);
    g_signal_connect (G_OBJECT (button), "released", G_CALLBACK (releas), (gpointer) STOP_A);
    gtk_table_attach_defaults (GTK_TABLE (table), button, 0, 1, 0, 1);
	gtk_widget_show (button); 
	
	button = gtk_button_new_with_label ("\\/");
    g_signal_connect (G_OBJECT (button), "pressed", G_CALLBACK (callback), (gpointer) REV_B);
    g_signal_connect (G_OBJECT (button), "released", G_CALLBACK (releas), (gpointer) STOP_B);
    gtk_table_attach_defaults (GTK_TABLE (table), button, 1, 2, 0, 1);
	gtk_widget_show (button); 
	
	button = gtk_button_new_with_label ("\\/");
    g_signal_connect (G_OBJECT (button), "pressed", G_CALLBACK (callback), (gpointer) REV_C);
    g_signal_connect (G_OBJECT (button), "released", G_CALLBACK (releas), (gpointer) STOP_C);
    gtk_table_attach_defaults (GTK_TABLE (table), button, 2, 3, 0, 1);
	gtk_widget_show (button);
	
	gtk_table_set_col_spacings(GTK_TABLE(table), 5);
    
    gtk_widget_show (table);
    
    /*
     * Program button
     */
    
    table = gtk_table_new (1, 3, TRUE);
    gtk_table_attach_defaults(GTK_TABLE(table2), table, 0, 1, 7, 8);
	
	button = gtk_button_new_with_label ("P1");
    g_signal_connect (G_OBJECT (button), "clicked", G_CALLBACK (callback), (gpointer) P1);
    gtk_table_attach_defaults (GTK_TABLE (table), button, 0, 1, 0, 1);
	gtk_widget_show (button); 
	
	label = gtk_label_new("Program");
	gtk_table_attach_defaults (GTK_TABLE (table), label, 1, 2, 0, 1);
	gtk_widget_show (label); 
	
	button = gtk_button_new_with_label ("P2");
    g_signal_connect (G_OBJECT (button), "clicked", G_CALLBACK (callback), (gpointer) P2);
    gtk_table_attach_defaults (GTK_TABLE (table), button, 2, 3, 0, 1);
	gtk_widget_show (button); 
	
	gtk_table_set_col_spacings(GTK_TABLE(table), 5);
	
	gtk_widget_show(table);
	
	table = gtk_table_new (1, 3, TRUE);
    gtk_table_attach_defaults(GTK_TABLE(table2), table, 0, 1, 8, 9);
	
	button = gtk_button_new_with_label ("P3");
    g_signal_connect (G_OBJECT (button), "clicked", G_CALLBACK (callback), (gpointer) P3);
    gtk_table_attach_defaults (GTK_TABLE (table), button, 0, 1, 0, 1);
	gtk_widget_show (button); 
	
	button = gtk_button_new_with_label ("P4");
    g_signal_connect (G_OBJECT (button), "clicked", G_CALLBACK (callback), (gpointer) P4);
    gtk_table_attach_defaults (GTK_TABLE (table), button, 1, 2, 0, 1);
	gtk_widget_show (button); 
	
	button = gtk_button_new_with_label ("P5");
    g_signal_connect (G_OBJECT (button), "clicked", G_CALLBACK (callback), (gpointer) P5);
    gtk_table_attach_defaults (GTK_TABLE (table), button, 2, 3, 0, 1);
	gtk_widget_show (button);
	
	gtk_table_set_col_spacings(GTK_TABLE(table), 5);
    
    gtk_widget_show (table);
    
	table = gtk_table_new (1, 3, TRUE);
    gtk_table_attach_defaults(GTK_TABLE(table2), table, 0, 1, 9, 10);
	
	/*
	 * Other button
	 */
	
	button = gtk_button_new_with_label ("Stop");
    g_signal_connect (G_OBJECT (button), "clicked", G_CALLBACK (callback), (gpointer) STOP);
    gtk_table_attach_defaults (GTK_TABLE (table), button, 0, 1, 0, 1);
	gtk_widget_show (button); 
	
	button = gtk_button_new_with_label ("Beep");
    g_signal_connect (G_OBJECT (button), "clicked", G_CALLBACK (callback), (gpointer) BEEP);
    gtk_table_attach_defaults (GTK_TABLE (table), button, 2, 3, 0, 1);
	gtk_widget_show (button);
	
	gtk_table_set_col_spacings(GTK_TABLE(table), 5);
    
    gtk_widget_show (table);
    
    gtk_widget_show (table2);
    gtk_widget_show (window); //display window
}
