/*
 * LinRemote : a program to emulate Mindstorms Remote under linux
 * Copyright (C) 2003  nanobapt
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 */

#include <stdio.h>
#include <stdlib.h>
#include <gtk/gtk.h>
#include <unistd.h>
#include <string.h>
#include "gtk_mode.h"
#include "IO.h"
#include "text_mode.h"

int main(int argc, char *argv[] )
{
	int fd =-1;
	int i;
	
	//fd = iTTY(); //init TTY "/dev/ttyS0 is the default one
	
	if(argc > 1)
	{
		for(i=0; i<argc-1; i++)
		{		
			if(!strcmp(argv[i+1], (char*)"-t"))
			{
				if(fd<0)
					fd = iTTY(NULL);
				t_mod(argc-i, &argv[i], fd);
				i=argc+5;
			}
			else if(!strcmp(argv[i+1], (char*)"-m"))
			{
				//display motor value
				printf("Float=0/Brake=1:Off=0/On=1:Power:Rev=0/Fwd=1\n");
			}
			else if(!strcmp(argv[i+1], (char*)"-tty"))
			{
				if(argc>i+1)
					fd = iTTY(argv[i+2]);
				else
				{
					printf("Need arg for -tty option\n");
					exit(1);
				}
				i++;
				if(argc == 3)
				{
					gtk_init (&argc, &argv); //gtk init
 		 		  cWin(fd); //create and display window
	  		      gtk_main (); //gtk loop
				}
			}
			else 
			{
				printf("Arg ERROR ->%s<-\n", argv[i+1]);
				exit(1);
			}
		}
	}
	else 
	{
		fd=iTTY(NULL);
 	   gtk_init (&argc, &argv); //gtk init
  	  cWin(fd); //create and display window
        gtk_main (); //gtk loop
	}
    
    close(fd); //close TTY
    
#ifdef DEBUG
	printf("End **\n");
#endif

    return EXIT_SUCCESS;
}
