/*
 * LinRemote : a program to emulate Mindstorms Remote under linux
 * Copyright (C) 2003  nanobapt
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 */

/*
 * Function to command the RCX
 */

#include <gtk/gtk.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include "IO.h"
 
unsigned char alt=0x00;
int type=0x00;

void dMotor(unsigned char data)
{
	unsigned char tmp;
	unsigned char tmp2;
	
	tmp = data/0x10; //Which motor ?
	tmp = tmp/4; // pass two bit
	printf("%d:", tmp%2);//0 = Float, 1 = Brake
	
	tmp = tmp/2;
	printf("%d:", tmp%2);//0 = Off, 1 = On
	
	tmp = data - (data/0x10)*0x10;
	tmp2 = tmp%2 + ((tmp/2)%2)*2 + ((tmp/4)%2)*4;
	printf("%d:", tmp2);//power setting
	
	tmp = tmp/8;
	printf("%d", tmp%2);//1 = FWD, 0 = REV
	
	printf("\n");
}

void command(gpointer data, int mode, int fd)
{
	unsigned char code[10];
	int log;
	
	if(mode == TEXT_MODE)
	{
		if ((log = open("alt", O_RDWR)) < 0)  // open it
 	   {//file does not exist
#ifdef DEBUG
		printf("alt file don't exist : create it");
#endif
  	  	if ((log = open("alt", O_CREAT|O_RDWR, S_IWUSR|S_IRUSR)) < 0)  // create it
			{
				perror("open alt file ");
				exit(1);
			}
			if(!write(log, 0x00, sizeof(unsigned char)))
			{
				perror("write ERROR");
				exit(1);
			}
 	   }
		if(!read(log, &alt, sizeof(unsigned char)))
		{
			perror("write ERROR");
			exit(1);
		}
#ifdef DEBUG
		printf("alt : %X\n", alt);
#endif
	}
    
	if(alt == 0x00)
		alt=0x08;
	else
		alt=0x00;
		
	if(data == (gpointer)MESSAGE_1)
	{
		code[0]=0xF7+alt;
		code[1]=0x00;
		send(code, 2, fd, FALSE);
	}
	else if(data == (gpointer)MESSAGE_2)
	{
		code[0]=0xF7+alt;
		code[1]=0x01;
		send(code, 2, fd, FALSE);
	}
	else if(data == (gpointer)MESSAGE_3)
	{
		code[0]=0xF7+alt;
		code[1]=0x02;
		send(code, 2, fd, FALSE);
	}
	else if(data == (gpointer)FWD_A)
	{
		code[0]=0xE1+alt;
		code[1]=0x81;
		send(code, 2, fd, FALSE);
		usleep(100000);
		code[0]=0x21+alt;
		code[1]=0x81;
		send(code, 2, fd, FALSE);
	}
	else if(data == (gpointer)FWD_B)
	{
		code[0]=0xE1+alt;
		code[1]=0x82;
		send(code, 2, fd, FALSE);
		usleep(100000);
		code[0]=0x21+alt;
		code[1]=0x82;
		send(code, 2, fd, FALSE);
	}
	else if(data == (gpointer)FWD_C)
	{
		code[0]=0xE1+alt;
		code[1]=0x84;
		send(code, 2, fd, FALSE);
		usleep(100000);
		code[0]=0x21+alt;
		code[1]=0x84;
		send(code, 2, fd, FALSE);
	}
	else if(data == (gpointer)REV_A)
	{
		code[0]=0xE1+alt;
		code[1]=0x81;
		send(code, 2, fd, FALSE);
		usleep(100000);
		
		if(alt == 0x00)
			alt=0x08;
		else
			alt=0x00;

		code[0]=0xE1+alt;
		code[1]=0x41;
		send(code, 2, fd, FALSE);
		usleep(100000);
			
		code[0]=0x21+alt;
		code[1]=0x81;
		send(code, 2, fd, FALSE);		
	}
	else if(data == (gpointer)REV_B)
	{
		code[0]=0xE1+alt;
		code[1]=0x82;
		send(code, 2, fd, FALSE);
		usleep(100000);
		
		if(alt == 0x00)
			alt=0x08;
		else
			alt=0x00;

		code[0]=0xE1+alt;
		code[1]=0x42;
		send(code, 2, fd, FALSE);
		usleep(100000);
		
		code[0]=0x21+alt;
		code[1]=0x82;
		send(code, 2, fd, FALSE);
	}
	else if(data == (gpointer)REV_C)
	{
		code[0]=0xE1+alt;
		code[1]=0x84;
		send(code, 2, fd, FALSE);
		usleep(100000);

		if(alt == 0x00)
			alt=0x08;
		else
			alt=0x00;

		code[0]=0xE1+alt;
		code[1]=0x44;
		send(code, 2, fd, FALSE);
		usleep(100000);

		code[0]=0x21+alt;
		code[1]=0x84;
		send(code, 2, fd, FALSE);
	}
	else if(data == (gpointer)STOP)
	{
		if(alt == 0x00)
			alt=0x08;
		else
			alt=0x00;
			
		code[0]=0x21+alt;
		code[1]=0x41;
		send(code, 2, fd, FALSE);
		usleep(100000);
		
		if(alt == 0x00)
			alt=0x08;
		else
			alt=0x00;
			
		code[0]=0x21+alt;
		code[1]=0x42;
		send(code, 2, fd, FALSE);
		usleep(100000);
		
		if(alt == 0x00)
			alt=0x08;
		else
			alt=0x00;
		
		code[0]=0x21+alt;
		code[1]=0x44;
		send(code, 2, fd, FALSE);
	}
	else if(data == (gpointer)BEEP)
	{
		code[0]=0x51+alt;
		code[1]=0x00;
		send(code, 2, fd, FALSE);
	}
	else if(data == (gpointer)P1)
	{
		code[0]=0xD2;
		code[1]=0x02;
		code[2]=0x00;
		send(code, 3, fd, FALSE);
		usleep(100000);
		code[0]=0xD2;
		code[1]=0x02;
		code[2]=0x00;
		send(code, 3, fd, FALSE);
		usleep(100000);
		code[0]=0xD2;
		code[1]=0x02;
		code[2]=0x00;
		send(code, 3, fd, FALSE);
	}
	else if(data == (gpointer)P2)
	{
		code[0]=0xD2;
		code[1]=0x04;
		code[2]=0x00;
		send(code, 3, fd, FALSE);
		usleep(100000);
		code[0]=0xD2;
		code[1]=0x04;
		code[2]=0x00;
		send(code, 3, fd, FALSE);
		usleep(100000);code[0]=0xD2;
		code[1]=0x04;
		code[2]=0x00;
		send(code, 3, fd, FALSE);
	}
	else if(data == (gpointer)P3)
	{
		code[0]=0xD2;
		code[1]=0x08;
		code[2]=0x00;
		send(code, 3, fd, FALSE);
		usleep(100000);
		code[0]=0xD2;
		code[1]=0x08;
		code[2]=0x00;
		send(code, 3, fd, FALSE);
		usleep(100000);
		code[0]=0xD2;
		code[1]=0x08;
		code[2]=0x00;
		send(code, 3, fd, FALSE);
	}
	else if(data == (gpointer)P4)
	{
		code[0]=0xD2;
		code[1]=0x10;
		code[2]=0x00;
		send(code, 3, fd, FALSE);
		usleep(100000);
		code[0]=0xD2;
		code[1]=0x10;
		code[2]=0x00;
		send(code, 3, fd, FALSE);
		usleep(100000);
		code[0]=0xD2;
		code[1]=0x10;
		code[2]=0x00;
		send(code, 3, fd, FALSE);
	}
	else if(data == (gpointer)P5)
	{
		code[0]=0xD2;
		code[1]=0x20;
		code[2]=0x00;
		send(code, 3, fd, FALSE);
		usleep(100000);
		code[0]=0xD2;
		code[1]=0x20;
		code[2]=0x00;
		send(code, 3, fd, FALSE);
		usleep(100000);
		code[0]=0xD2;
		code[1]=0x20;
		code[2]=0x00;
		send(code, 3, fd, FALSE);
	}	
	else if(data == (gpointer)STOP_A)
	{
		code[0]=0x21+alt;
		code[1]=0x41;
		send(code, 2, fd, FALSE);
	}
	else if(data == (gpointer)STOP_B)
	{
		code[0]=0x21+alt;
		code[1]=0x42;
		send(code, 2, fd, FALSE);
	}
	else if(data == (gpointer)STOP_C)
	{
		code[0]=0x21+alt;
		code[1]=0x44;
		send(code, 2, fd, FALSE);
	}
	else if((data == (gpointer)POLL_MOTOR_A) || (data == (gpointer)POLL_MOTOR_B) || (data == (gpointer)POLL_MOTOR_C))
	{
		unsigned char *rcv;
		rcv=malloc(4);
		
		code[0]=0x12+alt;
		code[1]=0x03;
		if(data == (gpointer)POLL_MOTOR_A)
			code[2]=0x00;
		else if(data == (gpointer)POLL_MOTOR_B)
			code[2]=0x01;
		else if(data == (gpointer)POLL_MOTOR_C)
			code[2]=0x02;
			
		if((rcv=send(code, 3, fd, TRUE)))
			if(rcv[1]==0xFF-(0x12+alt))
			{
				if(data == (gpointer)POLL_MOTOR_A)
					printf("A:");
				else if(data == (gpointer)POLL_MOTOR_B)
					printf("B:");
				else if(data == (gpointer)POLL_MOTOR_C)
					printf("C:");
				dMotor(rcv[2]);
			}
		usleep(100000);
	}
	else if((data == (gpointer)POLL_SENSOR_1) || (data == (gpointer)POLL_SENSOR_2) || (data == (gpointer)POLL_SENSOR_3))
	{
		unsigned char *rcv;
		rcv=malloc(4);
		
		code[0]=0x12+alt;
		code[1]=0x09;
		if(data == (gpointer)POLL_SENSOR_1)
			code[2]=0x00;
		else if(data == (gpointer)POLL_SENSOR_2)
			code[2]=0x01;
		else if(data == (gpointer)POLL_SENSOR_3)
			code[2]=0x02;
			
		if((rcv=send(code, 3, fd, TRUE)))
			if(rcv[1]==0xFF-(0x12+alt))
			{
#ifdef DEBUG
				printf("LO %X HI %X\n", rcv[2], rcv[3]);
#endif
				if(16*16*rcv[3]+rcv[2]<32767)
					printf("%d\n", 16*16*rcv[3]+rcv[2]);
				else
					printf("-%d\n", 65536-(16*16*rcv[3]+rcv[2]));
			}
		usleep(100000);
	}
	else if(data == (gpointer)NONE)
	{
		type=0x00;
		if(alt == 0x00)
			alt=0x08;
		else
			alt=0x00;
	}		
	else if(data == (gpointer)TOUCH)
	{
		type=0x01;
		if(alt == 0x00)
			alt=0x08;
		else
			alt=0x00;
	}
	else if(data == (gpointer)TEMPERATURE)
	{
		type=0x02;
		if(alt == 0x00)
			alt=0x08;
		else
			alt=0x00;
	}
	else if(data == (gpointer)LIGHT)
	{
		type=0x03;
		if(alt == 0x00)
			alt=0x08;
		else
			alt=0x00;
	}
	else if(data == (gpointer)ANGLE)
	{
		type=0x04;
		if(alt == 0x00)
			alt=0x08;
		else
			alt=0x00;
	}
		
	else if((data == (gpointer)SS1) || (data == (gpointer)SS2) || (data == (gpointer)SS3))
	{
		code[0]=0x32+alt;
		if(data == (gpointer)SS1)
			code[1]=0x00;
		else if(data == (gpointer)SS2)
			code[1]=0x01;
		else if(data == (gpointer)SS3)
			code[1]=0x02;
		code[2]=type;
			
		send(code, 3, fd, TRUE);
	}
	
	
	if ((log = open("alt", O_RDWR)) < 0)  // open it
	{
		perror("open alt file ");
		exit(1);
	}
			
	
	if(!write(log, &alt, sizeof(unsigned char)))
	{
		perror("write ERROR");
		exit(1);
	}
	
	close(log);
}
