/*
 * LinRemote : a program to emulate Mindstorms Remote under linux
 * Copyright (C) 2003  nanobapt
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 */

/* 
 * Text mode function
 */
 
#include <stdio.h>
#include <string.h>
#include <gtk/gtk.h>
#include <unistd.h>
#include "IO.h"
#include "rcx_com.h"
#include "text_mode.h"

void t_mod(int argc, char *argv[], int fd)
{
	int i;
	
#ifdef DEBUG
	printf("Text mode ON\n");
#endif
	
	for(i=0; i<(argc-2); i++)
	{		
		
		// On motor FWD
		if(!strcmp((char *)"ON_FWD", argv[i+2]))
		{
			if(argc-3 != i)
				i++;
			else
			{
				printf("Need argument for \"%s\"\n", argv[i+2]);
				exit(1);
			}
				
			if(!strcmp((char *)"A", argv[i+2]))
				command((gpointer)FWD_A, TEXT_MODE, fd);
			else if(!strcmp((char *)"B", argv[i+2]))
				command((gpointer)FWD_B, TEXT_MODE, fd);
			else if(!strcmp((char *)"C", argv[i+2]))
				command((gpointer)FWD_C, TEXT_MODE, fd);
			else 
			{
				printf("Error syntax near -> \"%s\"\n", argv[i+2]);
				exit(1);
			}
		}
		// On motor REV
		else if(!strcmp((char *)"ON_REV", argv[i+2]))
		{
			if(argc-3 != i)
				i++;
			else
			{
				printf("Need argument for \"%s\"\n", argv[i+2]);
				exit(1);
			}
				
			if(!strcmp((char *)"A", argv[i+2]))
				command((gpointer)REV_A, TEXT_MODE, fd);
			else if(!strcmp((char *)"B", argv[i+2]))
				command((gpointer)REV_B, TEXT_MODE, fd);
			else if(!strcmp((char *)"C", argv[i+2]))
				command((gpointer)REV_C, TEXT_MODE, fd);
			else 
			{
				printf("Error syntax near -> \"%s\"\n", argv[i+2]);
				exit(1);
			}
		}
		// STOP motor
		else if(!strcmp((char *)"STOP", argv[i+2]))
		{
			if(argc-3 != i)
			{
				i++;
				if(!strcmp((char *)"A", argv[i+2]))
					command((gpointer)STOP_A, TEXT_MODE, fd);
				else if(!strcmp((char *)"B", argv[i+2]))
					command((gpointer)STOP_B, TEXT_MODE, fd);
				else if(!strcmp((char *)"C", argv[i+2]))
					command((gpointer)STOP_C, TEXT_MODE, fd);
				else 
				{
					printf("Error syntax near -> \"%s\"\n", argv[i+2]);
					exit(1);
				}
			}
			else
			{
				command((gpointer)STOP, TEXT_MODE, fd);
			}
		}
		else if(!strcmp((char *)"MSG", argv[i+2]))
		{
			if(argc-3 != i)
				i++;
			else
			{
				printf("Need argument for \"%s\"\n", argv[i+2]);
				exit(1);
			}
				
			if(!strcmp((char *)"1", argv[i+2]))
				command((gpointer)MESSAGE_1, TEXT_MODE, fd);
			else if(!strcmp((char *)"2", argv[i+2]))
				command((gpointer)MESSAGE_2, TEXT_MODE, fd);
			else if(!strcmp((char *)"3", argv[i+2]))
				command((gpointer)MESSAGE_3, TEXT_MODE, fd);
			else 
			{
				printf("Error syntax near -> \"%s\"\n", argv[i+2]);
				exit(1);
			}
		}
		// Run program
		else if(!strcmp((char *)"PGM", argv[i+2]))
		{
			if(argc-3 != i)
				i++;
			else
			{
				printf("Need argument for \"%s\"\n", argv[i+2]);
				exit(1);
			}
				
			if(!strcmp((char *)"1", argv[i+2]))
				command((gpointer)P1, TEXT_MODE, fd);
			else if(!strcmp((char *)"2", argv[i+2]))
				command((gpointer)P2, TEXT_MODE, fd);
			else if(!strcmp((char *)"3", argv[i+2]))
				command((gpointer)P3, TEXT_MODE, fd);
			else if(!strcmp((char *)"4", argv[i+2]))
				command((gpointer)P4, TEXT_MODE, fd);
			else if(!strcmp((char *)"5", argv[i+2]))
				command((gpointer)P5, TEXT_MODE, fd);
			else 
			{
				printf("Error syntax near -> \"%s\"\n", argv[i+2]);
				exit(1);
			}
		}
		// POLL
		else if(!strcmp((char *)"POLL", argv[i+2]))
		{
			if(argc-3 != i)
				i++;
			else
			{
				printf("Need argument for \"%s\"\n", argv[i+2]);
				exit(1);
			}
				
			if(!strcmp((char *)"MOTOR_A", argv[i+2]))
				command((gpointer)POLL_MOTOR_A, TEXT_MODE, fd);
			else if(!strcmp((char *)"MOTOR_B", argv[i+2]))
				command((gpointer)POLL_MOTOR_B, TEXT_MODE, fd);
			else if(!strcmp((char *)"MOTOR_C", argv[i+2]))
				command((gpointer)POLL_MOTOR_C, TEXT_MODE, fd);
			else if(!strcmp((char *)"SENSOR_1", argv[i+2]))
				command((gpointer)POLL_SENSOR_1, TEXT_MODE, fd);
			else if(!strcmp((char *)"SENSOR_2", argv[i+2]))
				command((gpointer)POLL_SENSOR_2, TEXT_MODE, fd);
			else if(!strcmp((char *)"SENSOR_3", argv[i+2]))
				command((gpointer)POLL_SENSOR_3, TEXT_MODE, fd);
			else 
			{
				printf("Error syntax near -> \"%s\"\n", argv[i+2]);
				exit(1);
			}
		}	
		else if(!strcmp((char *)"NONE", argv[i+2]))
			command((gpointer)NONE, TEXT_MODE, fd);
		else if(!strcmp((char *)"TOUCH", argv[i+2]))
			command((gpointer)TOUCH, TEXT_MODE, fd);
		else if(!strcmp((char *)"TEMPERATURE", argv[i+2]))
			command((gpointer)TEMPERATURE, TEXT_MODE, fd);
		else if(!strcmp((char *)"LIGHT", argv[i+2]))
			command((gpointer)LIGHT, TEXT_MODE, fd);
		else if(!strcmp((char *)"ANGLE", argv[i+2]))	
			command((gpointer)ANGLE, TEXT_MODE, fd);
			
		else if(!strcmp((char *)"PLUG_ON", argv[i+2]))
		{
			if(argc-3 != i)
				i++;
			else
			{
				printf("Need argument for \"%s\"\n", argv[i+2]);
				exit(1);
			}
				
			if(!strcmp((char *)"1", argv[i+2]))
				command((gpointer)SS1, TEXT_MODE, fd);
			else if(!strcmp((char *)"2", argv[i+2]))
				command((gpointer)SS2, TEXT_MODE, fd);
			else if(!strcmp((char *)"3", argv[i+2]))
				command((gpointer)SS3, TEXT_MODE, fd);
			
			else 
			{
				printf("Error syntax near -> \"%s\"\n", argv[i+2]);
				exit(1);
			}
		}
				
		else
		{
			printf("Error syntax near -> \"%s\"\n", argv[i+2]);
			exit(1);
		}
	usleep(100000);
	}
}
